blob: 618d7f1ac6c020e596abdc413609f3aa3180654f [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
6# http://nvie.com/archives/323
7#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
Vincent Driessend72acba2010-04-04 16:10:17 +020011# Copyright 2010 Vincent Driessen. All rights reserved.
12#
13# Redistribution and use in source and binary forms, with or without
14# modification, are permitted provided that the following conditions are met:
15#
16# 1. Redistributions of source code must retain the above copyright notice,
17# this list of conditions and the following disclaimer.
18#
19# 2. Redistributions in binary form must reproduce the above copyright
20# notice, this list of conditions and the following disclaimer in the
21# documentation and/or other materials provided with the distribution.
22#
23# THIS SOFTWARE IS PROVIDED BY VINCENT DRIESSEN ``AS IS'' AND ANY EXPRESS OR
24# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
25# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
26# EVENT SHALL VINCENT DRIESSEN OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
27# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
28# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
30# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
31# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
32# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33#
34# The views and conclusions contained in the software and documentation are
35# those of the authors and should not be interpreted as representing official
36# policies, either expressed or implied, of Vincent Driessen.
Benedikt Böhm00ccea62010-01-26 12:39:36 +010037#
38
Vincent Driessen7832d6e2010-02-21 21:31:03 +010039require_git_repo
40require_gitflow_initialized
Vincent Driessend72e4ac2010-02-16 21:33:51 +010041gitflow_load_settings
Vincent Driessenc1598bf2010-02-20 16:52:48 +010042PREFIX=$(git config --get gitflow.prefix.feature)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010043
Benedikt Böhm00ccea62010-01-26 12:39:36 +010044usage() {
Vincent Driessenb03cf962010-02-01 22:00:39 +010045 echo "usage: git flow feature [list] [-v]"
Vincent Driessena2e41162010-02-24 01:37:07 +010046 echo " git flow feature start [-Ff] <name> [<base>]"
47 echo " git flow feature finish [-rF] <name|nameprefix>"
Vincent Driessen186d2b52010-01-27 23:48:39 +010048 echo " git flow feature publish <name>"
49 echo " git flow feature track <name>"
Vincent Driessena2e41162010-02-24 01:37:07 +010050 echo " git flow feature diff [<name|nameprefix>]"
51 echo " git flow feature rebase [-i] [<name|nameprefix>]"
Vincent Driessend43ab842010-05-27 11:26:01 -070052 echo " git flow feature checkout [<name|nameprefix>]"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010053}
54
Vincent Driessen186d2b52010-01-27 23:48:39 +010055cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010056 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010057}
58
Vincent Driessenb866b012010-01-28 01:01:53 +010059cmd_list() {
Vincent Driessen44174922010-02-02 23:53:21 +010060 DEFINE_boolean verbose false 'verbose (more) output' v
Vincent Driessen1b819232010-02-01 15:51:43 +010061 parse_args "$@"
62
Vincent Driessenf46e2902010-02-15 23:01:52 +010063 local feature_branches
64 local current_branch
65 local short_names
Vincent Driessen7832d6e2010-02-21 21:31:03 +010066 feature_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010067 if [ -z "$feature_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010068 warn "No feature branches exist."
Randy Merrillb681b452010-06-26 13:14:15 +080069 warn ""
70 warn "You can start a new feature branch:"
71 warn ""
72 warn " git flow feature start <name> [<base>]"
Randy Merrill4de01f22010-06-26 13:19:06 +080073 warn ""
Vincent Driessen186d2b52010-01-27 23:48:39 +010074 exit 0
75 fi
Vincent Driessen27592dd2010-02-06 14:45:39 +010076 current_branch=$(git branch | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
77 short_names=$(echo "$feature_branches" | sed "s ^$PREFIX g")
Vincent Driessenf2536f42010-02-01 15:57:48 +010078
Vincent Driessenaa6d0162010-02-01 19:43:46 +010079 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010080 local width=0
81 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010082 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010083 local len=${#branch}
Vincent Driessenaa6d0162010-02-01 19:43:46 +010084 width=$(max $width $len)
85 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010086 width=$(($width+3))
Vincent Driessen1adbc3e2010-01-30 16:28:20 +010087
Vincent Driessenf46e2902010-02-15 23:01:52 +010088 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010089 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010090 local fullname=$PREFIX$branch
91 local base=$(git merge-base "$fullname" "$DEVELOP_BRANCH")
92 local develop_sha=$(git rev-parse "$DEVELOP_BRANCH")
93 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010094 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessenaa6d0162010-02-01 19:43:46 +010095 printf "* "
96 else
97 printf " "
98 fi
Vincent Driessen44174922010-02-02 23:53:21 +010099 if flag verbose; then
Vincent Driessen1adbc3e2010-01-30 16:28:20 +0100100 printf "%-${width}s" "$branch"
Vincent Driessenf2536f42010-02-01 15:57:48 +0100101 if [ "$branch_sha" = "$develop_sha" ]; then
102 printf "(no commits yet)"
103 elif [ "$base" = "$branch_sha" ]; then
104 printf "(is behind develop, may ff)"
105 elif [ "$base" = "$develop_sha" ]; then
106 printf "(based on latest develop)"
107 else
108 printf "(may be rebased)"
109 fi
Vincent Driessenaa6d0162010-02-01 19:43:46 +0100110 else
111 printf "%s" "$branch"
112 fi
113 echo
114 done
Vincent Driessen186d2b52010-01-27 23:48:39 +0100115}
116
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100117cmd_help() {
118 usage
119 exit 0
120}
121
Vincent Driessend0991262010-02-06 21:19:07 +0100122require_name_arg() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100123 if [ "$NAME" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100124 warn "Missing argument <name>"
Vincent Driessen1b819232010-02-01 15:51:43 +0100125 usage
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100126 exit 1
127 fi
128}
129
Vincent Driessend0991262010-02-06 21:19:07 +0100130expand_nameprefix_arg() {
131 require_name_arg
132
Vincent Driessenf46e2902010-02-15 23:01:52 +0100133 local expanded_name
134 local exitcode
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100135 expanded_name=$(gitflow_resolve_nameprefix "$NAME" "$PREFIX")
Vincent Driessend0991262010-02-06 21:19:07 +0100136 exitcode=$?
137 case $exitcode in
138 0) NAME=$expanded_name
139 BRANCH=$PREFIX$NAME
140 ;;
141 *) exit 1 ;;
142 esac
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100143}
144
Vincent Driessend0991262010-02-06 21:19:07 +0100145expand_nameprefix_arg_or_current() {
Vincent Driessenc62633f2010-02-02 10:48:50 +0100146 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100147 expand_nameprefix_arg
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100148 require_branch "$PREFIX$NAME"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100149 else
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100150 local current_branch=$(git_current_branch)
Vincent Driessend0991262010-02-06 21:19:07 +0100151 if startswith "$current_branch" "$PREFIX"; then
152 BRANCH=$current_branch
153 NAME=${BRANCH#$PREFIX}
154 else
155 warn "The current HEAD is no feature branch."
156 warn "To diff a feature, specify a <name> argument."
157 usage
158 exit 1
159 fi
Vincent Driessenc62633f2010-02-02 10:48:50 +0100160 fi
161}
162
Vincent Driessenea608952010-01-29 16:56:29 +0100163parse_args() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100164 # parse options
165 FLAGS "$@" || exit $?
166 eval set -- "${FLAGS_ARGV}"
167
168 # read arguments into global variables
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100169 NAME=$1
Vincent Driessen11560922010-02-01 21:58:37 +0100170 BRANCH=$PREFIX$NAME
Vincent Driessenb866b012010-01-28 01:01:53 +0100171}
172
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100173cmd_start() {
Vincent Driessen44174922010-02-02 23:53:21 +0100174 DEFINE_boolean fetch false 'fetch from origin before performing local operation' F
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100175 DEFINE_boolean force false 'force creation of feature branch (ignores dirty working tree)' f
Vincent Driessenea608952010-01-29 16:56:29 +0100176 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100177 BASE=${2:-$DEVELOP_BRANCH}
Vincent Driessend0991262010-02-06 21:19:07 +0100178 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100179
180 # sanity checks
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100181 if noflag force; then
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100182 require_clean_working_tree
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100183 fi
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100184 require_branch_absent "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100185
186 # update the local repo with remote changes, if asked
Vincent Driessen44174922010-02-02 23:53:21 +0100187 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100188 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100189 fi
190
Vincent Driessenc118a852010-04-04 16:32:04 +0200191 # if the origin branch counterpart exists, assert that the local branch
192 # isn't behind it (to avoid unnecessary rebasing)
193 if git_branch_exists "$ORIGIN/$DEVELOP_BRANCH"; then
194 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
195 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100196
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100197 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100198 if ! git checkout -b "$BRANCH" "$BASE"; then
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100199 die "Could not create feature branch '$BRANCH'"
200 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100201
202 echo
203 echo "Summary of actions:"
204 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
205 echo "- You are now on branch '$BRANCH'"
206 echo ""
207 echo "Now, start committing on your feature. When done, use:"
208 echo ""
gmallard192ff522010-04-01 19:31:09 -0400209 echo " git flow feature finish $NAME"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100210 echo
211}
212
213cmd_finish() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100214 DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F
Vincent Driessen44174922010-02-02 23:53:21 +0100215 DEFINE_boolean rebase false 'rebase instead of merge' r
Vincent Driessen1b819232010-02-01 15:51:43 +0100216 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100217 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100218
219 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100220 require_branch "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100221
Vincent Driessen49c7d022010-01-28 12:40:33 +0100222 # detect if we're restoring from a merge conflict
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100223 if [ -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE" ]; then
Vincent Driessen49c7d022010-01-28 12:40:33 +0100224 #
225 # TODO: detect that we're working on the correct branch here!
226 # The user need not necessarily have given the same $NAME twice here
227 # (although he/she should).
228 #
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100229
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100230 # TODO: git_is_clean_working_tree() should provide an alternative
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100231 # exit code for "unmerged changes in working tree", which we should
232 # actually be testing for here
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100233 if git_is_clean_working_tree; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100234 FINISH_BASE=$(cat "$DOT_GIT_DIR/.gitflow/MERGE_BASE")
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100235
236 # Since the working tree is now clean, either the user did a
237 # succesfull merge manually, or the merge was cancelled.
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100238 # We detect this using git_is_branch_merged_into()
239 if git_is_branch_merged_into "$BRANCH" "$FINISH_BASE"; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100240 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100241 helper_finish_cleanup
242 exit 0
243 else
244 # If the user cancelled the merge and decided to wait until later,
245 # that's fine. But we have to acknowledge this by removing the
246 # MERGE_BASE file and continuing normal execution of the finish
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100247 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100248 fi
Vincent Driessen49c7d022010-01-28 12:40:33 +0100249 else
250 echo
251 echo "Merge conflicts not resolved yet, use:"
252 echo " git mergetool"
253 echo " git commit"
254 echo
255 echo "You can then complete the finish by running it again:"
256 echo " git flow feature finish $NAME"
257 echo
258 exit 1
259 fi
260 fi
261
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100262 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100263 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100264
Vincent Driessene034e4a2010-01-29 12:10:44 +0100265 # update local repo with remote changes first, if asked
Vincent Driessen44174922010-02-02 23:53:21 +0100266 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100267 git fetch -q "$ORIGIN" "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100268 fi
269
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100270 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
271 require_branches_equal "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100272 fi
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100273 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100274
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100275 # if the user wants to rebase, do that first
Vincent Driessen44174922010-02-02 23:53:21 +0100276 if flag rebase; then
Vincent Driessen010252a2010-02-04 10:31:29 +0100277 if ! git flow feature rebase "$NAME" "$DEVELOP_BRANCH"; then
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100278 warn "Finish was aborted due to conflicts during rebase."
279 warn "Please finish the rebase manually now."
280 warn "When finished, re-run:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100281 warn " git flow feature finish '$NAME' '$DEVELOP_BRANCH'"
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100282 exit 1
283 fi
284 fi
285
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100286 # merge into BASE
Vincent Driessena4dd2232010-02-10 00:34:59 +0100287 git checkout "$DEVELOP_BRANCH"
288 if [ "$(git rev-list -n2 "$DEVELOP_BRANCH..$BRANCH" | wc -l)" -eq 1 ]; then
289 git merge --ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100290 else
Vincent Driessena4dd2232010-02-10 00:34:59 +0100291 git merge --no-ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100292 fi
293
Vincent Driessen49c7d022010-01-28 12:40:33 +0100294 if [ $? -ne 0 ]; then
295 # oops.. we have a merge conflict!
Vincent Driessen010252a2010-02-04 10:31:29 +0100296 # write the given $DEVELOP_BRANCH to a temporary file (we need it later)
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100297 mkdir -p "$DOT_GIT_DIR/.gitflow"
298 echo "$DEVELOP_BRANCH" > "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessen49c7d022010-01-28 12:40:33 +0100299 echo
300 echo "There were merge conflicts. To resolve the merge conflict manually, use:"
301 echo " git mergetool"
302 echo " git commit"
303 echo
304 echo "You can then complete the finish by running it again:"
305 echo " git flow feature finish $NAME"
306 echo
307 exit 1
308 fi
309
310 # when no merge conflict is detected, just clean up the feature branch
311 helper_finish_cleanup
312}
313
314helper_finish_cleanup() {
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100315 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100316 require_branch "$BRANCH"
317 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100318
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100319 # delete branch
Vincent Driessen44174922010-02-02 23:53:21 +0100320 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100321 git push "$ORIGIN" ":refs/heads/$BRANCH"
Vincent Driesseneec73c62010-02-02 16:14:16 +0100322 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100323 git branch -d "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100324
325 echo
326 echo "Summary of actions:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100327 echo "- The feature branch '$BRANCH' was merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100328 #echo "- Merge conflicts were resolved" # TODO: Add this line when it's supported
329 echo "- Feature branch '$BRANCH' has been removed"
Vincent Driessen010252a2010-02-04 10:31:29 +0100330 echo "- You are now on branch '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100331 echo
332}
333
334cmd_publish() {
Vincent Driessenea608952010-01-29 16:56:29 +0100335 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100336 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100337
338 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100339 require_clean_working_tree
340 require_branch "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100341 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100342 require_branch_absent "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100343
344 # create remote branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100345 git push "$ORIGIN" "$BRANCH:refs/heads/$BRANCH"
346 git fetch -q "$ORIGIN"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100347
348 # configure remote tracking
Vincent Driessena4dd2232010-02-10 00:34:59 +0100349 git config "branch.$BRANCH.remote" "$ORIGIN"
350 git config "branch.$BRANCH.merge" "refs/heads/$BRANCH"
351 git checkout "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100352
353 echo
354 echo "Summary of actions:"
355 echo "- A new remote branch '$BRANCH' was created"
356 echo "- The local branch '$BRANCH' was configured to track the remote branch"
357 echo "- You are now on branch '$BRANCH'"
358 echo
359}
360
361cmd_track() {
Vincent Driessenea608952010-01-29 16:56:29 +0100362 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100363 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100364
365 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100366 require_clean_working_tree
367 require_branch_absent "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100368 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100369 require_branch "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100370
371 # create tracking branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100372 git checkout -b "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100373
374 echo
375 echo "Summary of actions:"
376 echo "- A new remote tracking branch '$BRANCH' was created"
377 echo "- You are now on branch '$BRANCH'"
378 echo
379}
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100380
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100381cmd_diff() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100382 parse_args "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100383
Vincent Driessen5474e462010-02-04 15:50:06 +0100384 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100385 expand_nameprefix_arg
Vincent Driessena4dd2232010-02-10 00:34:59 +0100386 BASE=$(git merge-base "$DEVELOP_BRANCH" "$BRANCH")
387 git diff "$BASE..$BRANCH"
Vincent Driessen5474e462010-02-04 15:50:06 +0100388 else
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100389 if ! git_current_branch | grep -q "^$PREFIX"; then
Vincent Driessen5474e462010-02-04 15:50:06 +0100390 die "Not on a feature branch. Name one explicitly."
391 fi
392
Vincent Driessena4dd2232010-02-10 00:34:59 +0100393 BASE=$(git merge-base "$DEVELOP_BRANCH" HEAD)
394 git diff "$BASE"
Vincent Driessen5474e462010-02-04 15:50:06 +0100395 fi
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100396}
Vincent Driessenc62633f2010-02-02 10:48:50 +0100397
Vincent Driessend43ab842010-05-27 11:26:01 -0700398cmd_checkout() {
399 parse_args "$@"
400
401 if [ "$NAME" != "" ]; then
402 expand_nameprefix_arg
403 git checkout "$BRANCH"
404 else
405 die "Name a feature branch explicitly."
406 fi
407}
408
Vincent Driessena2baef92010-05-27 11:52:31 -0700409cmd_co() {
410 # Alias for checkout
411 cmd_checkout "$@"
412}
413
Vincent Driessenc62633f2010-02-02 10:48:50 +0100414cmd_rebase() {
Vincent Driessen44174922010-02-02 23:53:21 +0100415 DEFINE_boolean interactive false 'do an interactive rebase' i
Vincent Driessenc62633f2010-02-02 10:48:50 +0100416 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100417 expand_nameprefix_arg_or_current
Vincent Driessenc62633f2010-02-02 10:48:50 +0100418 warn "Will try to rebase '$NAME'..."
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100419 require_clean_working_tree
420 require_branch "$BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100421
422 git checkout -q "$BRANCH"
Vincent Driessenf46e2902010-02-15 23:01:52 +0100423 local OPTS=
Vincent Driessen44174922010-02-02 23:53:21 +0100424 if flag interactive; then
Vincent Driessenc62633f2010-02-02 10:48:50 +0100425 OPTS="$OPTS -i"
426 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100427 git rebase $OPTS "$DEVELOP_BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100428}